"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const rxjs_1 = require("rxjs");
/**
 * Extractor that reads a JSON file at a given filepath. The path is resolved relatively to the running tasks root dir.
 */
class JsonExtractor {
    constructor(filePath) {
        this.filePath = path_1.resolve(process.cwd(), filePath);
    }
    read() {
        try {
            const content = require(this.filePath);
            if (!(content instanceof Array) && content.constructor !== Array) {
                return rxjs_1.Observable.from([content]);
            }
            return rxjs_1.Observable.from(content);
        }
        catch (e) {
            return rxjs_1.Observable.throw(e);
        }
    }
}
exports.JsonExtractor = JsonExtractor;
