"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rxjs_1 = require("rxjs");
class MatchMergeTransformer {
    process(observable, context) {
        const matchMerge = (merged, o2) => {
            return this.matchMerge(merged, o2, context);
        };
        return observable.reduce(matchMerge, []).flatMap((merged) => {
            return rxjs_1.Observable.from(merged);
        });
    }
    matchMerge(merged, o2, context) {
        for (let i = 0; i < merged.length; i++) {
            if (this.match(merged[i], o2, context)) {
                const o1 = merged.splice(i, 1)[0];
                // tslint:disable-next-line
                o2 = this.merge(o1, o2, context);
                // Try to merge the merged element with the remaining elements,
                // starting from the current position
                i--;
            }
        }
        merged.push(o2);
        return merged;
    }
}
exports.MatchMergeTransformer = MatchMergeTransformer;
